//importieren von Bibliotheken, etc
import ch.aplu.jgamegrid.*;

public class Ball extends Actor //Klasse Ball als Actor
{
  private float StartBallVY; //Startgeschwindigkeit in y Richtung (unrelevant)
  private float StartBallVX = (float)0.1; //Startgeschwindigkeit in x Richtung (relevant)
  private float BallVX; //Geschwindigkeit in X Richtung
  private float BallVY; //Geschwindigkeit in Y Richtung
  private float BallX; //X Position
  private float BallY; //Y Position
  private float V; //Geschwindigkeit
  private int Damage = 50; //Schaden pro Treffer

  public Ball() //Konstruktor
  {
    super("sprites/Ball2.png"); //Aufruf des Konstruktors von Actor mit dem String des Bilds
  }

  public void set_V(float set) //Funktion zum Setzen von V
  {
    V = set; //V bekommt den Wert von set
  }

  public void prepare_BallX() //Funktion zum Abgleichen von BallX und X
  {
    BallX = (float)getX(); //BallX bekommt den Wert von X
  }

  public void prepare_BallY()//Funktion zum Abgleichen von BallY und Y
  {
    BallY = (float)getY();//BallY bekommt den Wert von Y
  }

  public int get_Damage() //Funktion zum Abrufen des Schadens
  {
    return Damage; //Schaden wird zurückgegeben
  }

  public void restoreVX() //Zurücksetzen von BallVX
  {
    BallVX = StartBallVX; //BallVX bekommt den Wert von StartBallVX
  }

  public float getVX()//Zurücksetzen von BallVY
  {
    return (BallVX);//BallVY bekommt den Wert von StartBallVY
  }

  public float getVY() //Abrufen von VY
  {
    return (BallVY); //gibt BallVY zurück
  }

  public void AbprallenY(int Zusatz) //Abprallen in Y-Richtung
  {
    boolean change = false; //Variable zum Ausgleichen der Quadratfunktion
    if (BallVY > 0)
    {
      change = true;
    } //Variable wird auf true gesetzt, wenn BallVY größer ist als 0, da der Ball ansonsten weiterhin in diese Richtung fliegen würde
    BallVX = BallVX + ((float)Zusatz / (float)30); //dazuaddieren des Zusatzes/30 zu BallVX
    changeVX(); //Ausgleichen der Änderung von VX in VY-Richtung
    if (change == true)
    {
      BallVY = -BallVY;
    } //Ausgleichen der Quadratfunktion
    BallY = BallY + BallVY; //Rückgängigmachen der letzten Bewegung ind den Gegenstand hinein
    setY((int)BallY); //Abgleichen von Y und BallY
    V = V + (float)0.03; //Erhöhung der Geschwindigkeit um 0.03
  }

  public void AbprallenX()//Abprallen in X-Richtung
  {
    BallVX = -BallVX; //Ändern der Bewegungsrichtung
    BallX = BallX + BallVX; //Rückgängigmachen der letzten Bewegung ind den Gegenstand hinein
    setX((int)BallX);//Abgleichen von X und BallX
    V = V + (float)0.03;//Erhöhung der Geschwindigkeit um 0.03
  }

  public void moveX() //Bewegen in X Richtung
  {
    BallX = BallX + BallVX; //Bewegung in X Richtung
    setX((int)BallX); //Abgleichen von X und BallX
  }

  public void moveY()//Bewegen in Y Richtung
  {
    BallY = BallY + BallVY;//Bewegung in Y Richtung
    setY((int)BallY);//Abgleichen von X und BallX
  }

  public void changeVX() //Ausgleichen der Änderung von BallVX
  {
    if (BallVX > V) //BallVX darf nicht größer sein als V
    {
      BallVX = V - (float)0.1; //Beinahe-Erreichen, da sonst kein rechter Winkel mehr gegeben wäre
    }

    if (BallVX < -V)//BallVY darf nicht größer sein als V
    {
      BallVX = -V + (float)0.1; //Beinahe-Erreichen, da sonst kein rechter Winkel mehr gegeben wäre
    }

    BallVY = (float)Math.sqrt(V * V - BallVX * BallVX); //b=Wurzel(c^2-a^2)
  }

}
